Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/include/Functionnal_unit.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/include/Functionnal_unit.h	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/include/Functionnal_unit.h	(revision 75)
@@ -55,5 +55,5 @@
 
 #ifdef STATISTICS
-  private   : Stat                           * _stat;
+  public    : Stat                           * _stat;
 
   private   : counter_t                      * _stat_use_functionnal_unit;
@@ -162,5 +162,4 @@
 #ifdef STATISTICS
   public  : void        statistics_declaration    (morpheo::behavioural::Parameters_Statistics * param_statistics);
-  public  : std::string statistics_print          (uint32_t depth);
 #endif
 					       
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Functionnal_unit_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Functionnal_unit_allocation.cpp	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Functionnal_unit_allocation.cpp	(revision 75)
@@ -21,6 +21,4 @@
   void Functionnal_unit::allocation (void)
   {
-    string rename;
-
     log_printf(FUNC,Functionnal_unit,FUNCTION,"Begin");
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Functionnal_unit_statistics_declaration.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Functionnal_unit_statistics_declaration.cpp	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Functionnal_unit_statistics_declaration.cpp	(revision 75)
@@ -25,5 +25,5 @@
     log_printf(FUNC,Functionnal_unit,FUNCTION,"Begin");
 
-    _stat = new Stat (static_cast<string>(_name),
+    _stat = new Stat (static_cast<std::string>(_name),
 		      "Functionnal_unit",
 		      param_statistics);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/SelfTest/include/Cache.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/SelfTest/include/Cache.h	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/SelfTest/include/Cache.h	(revision 75)
@@ -27,5 +27,5 @@
 private : const uint32_t    _miss_rate;
 private : const uint32_t    _miss_penality;
-private : list<cache_rsp_t> _list_respons;
+private : std::list<cache_rsp_t> _list_respons;
 					 
 public  : Cache_t (uint32_t miss_rate, uint32_t miss_penality):
@@ -59,5 +59,5 @@
 
     // find good place
-    list<cache_rsp_t>::iterator i;
+    std::list<cache_rsp_t>::iterator i;
     for(i = _list_respons.begin(); (i != _list_respons.end()) and (i->_cycle<=cycle); i++);
 
@@ -82,5 +82,5 @@
 public  : void end_cycle (void)
   {
-    for(list<cache_rsp_t>::iterator i = _list_respons.begin(); i != _list_respons.end(); i++)
+    for(std::list<cache_rsp_t>::iterator i = _list_respons.begin(); i != _list_respons.end(); i++)
       {
 	i->_cycle --;
@@ -90,5 +90,5 @@
 public  : void print (void)
   {
-    for(list<cache_rsp_t>::iterator i = _list_respons.begin(); i != _list_respons.end(); i++)
+    for(std::list<cache_rsp_t>::iterator i = _list_respons.begin(); i != _list_respons.end(); i++)
       {
 	std::cout << "{" << i->_cycle << "}\t" 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/SelfTest/include/Memory.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/SelfTest/include/Memory.h	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/SelfTest/include/Memory.h	(revision 75)
@@ -53,10 +53,10 @@
       }
 
-    cout << "=====[ Memory's information ]" << endl
-	 << "  * _nb_context : " << _nb_context << endl
-	 << "  * _nb_word    : " << _nb_word    << endl
-	 << "  * _size_word  : " << _size_word  << endl
-	 << "  * _shift_addr : " << _shift_addr << endl
-	 << "  * _mask_addr  : " << hex << _mask_addr << dec << endl;
+    std::cout << "=====[ Memory's information ]" << std::endl
+	      << "  * _nb_context : " << _nb_context << std::endl
+	      << "  * _nb_word    : " << _nb_word    << std::endl
+	      << "  * _size_word  : " << _size_word  << std::endl
+	      << "  * _shift_addr : " << _shift_addr << std::endl
+	      << "  * _mask_addr  : " << std::hex << _mask_addr << std::dec << std::endl;
   }
 
@@ -71,9 +71,9 @@
 						       morpheo::behavioural::Tdcache_data_t    data)
   {
-    cout << "<Memory::access>" << endl
-	 << " * context : " << context << endl
-	 << " * address : " << hex << address << dec << endl
-	 << " * type    : " << type << endl
-	 << " * wdata   : " << hex << data << dec << endl;
+    std::cout << "<Memory::access>" << std::endl
+	      << " * context : " << context << std::endl
+	      << " * address : " << std::hex << address << std::dec << std::endl
+	      << " * type    : " << type << std::endl
+	      << " * wdata   : " << std::hex << data << std::dec << std::endl;
 
     morpheo::behavioural::Tdcache_data_t rdata;
@@ -90,5 +90,5 @@
 	rdata = other (context, address, type);
 
-    cout << " * rdata   : " << hex << rdata << dec << endl;
+    std::cout << " * rdata   : " << std::hex << rdata << std::dec << std::endl;
 
     return rdata;
@@ -161,5 +161,5 @@
 						      morpheo::behavioural::Tdcache_data_t data)
   {
-    cout << "   * write" << endl;
+    std::cout << "   * write" << std::endl;
 
     if (context>_nb_context)
@@ -172,8 +172,8 @@
     morpheo::behavioural::Tdcache_address_t MSB = address >> _shift_addr;
 
-    cout << hex
-	 << "     * LSB         : " << LSB << endl
-	 << "     * MSB         : " << MSB << endl
-	 << dec;
+    std::cout << std::hex
+	 << "     * LSB         : " << LSB << std::endl
+	 << "     * MSB         : " << MSB << std::endl
+	 << std::dec;
   
     morpheo::behavioural::Tdcache_data_t data_old    = _data [context][MSB];
@@ -193,21 +193,21 @@
     uint32_t index_max = index_min+memory_size;
 
-    cout << "     * type        : " << type << endl
-	 << "     * memory_size : " << memory_size << endl
-	 << "     * index_min   : " << index_min << endl
-	 << "     * index_max   : " << index_max << endl;
+    std::cout << "     * type        : " << type << std::endl
+	 << "     * memory_size : " << memory_size << std::endl
+	 << "     * index_min   : " << index_min << std::endl
+	 << "     * index_max   : " << index_max << std::endl;
     
     morpheo::behavioural::Tdcache_data_t data_insert = data<<index_min; // the data is aligned at LSB
 
-//     cout << "read :" << endl
-// 	 << " * context     : " << context << endl
-// 	 << hex		    
-// 	 << " * address     : " << address << endl
-// 	 << "   * LSB       : " << LSB       << endl
-// 	 << "   * MSB       : " << MSB       << endl
-// 	 << dec
-// 	 << "   * index_min : " << index_min << endl
-// 	 << "   * index_max : " << index_max << endl
-// 	 << " * type        : " << type    << endl;
+//     std::cout << "read :" << std::endl
+// 	 << " * context     : " << context << std::endl
+// 	 << std::hex		    
+// 	 << " * address     : " << address << std::endl
+// 	 << "   * LSB       : " << LSB       << std::endl
+// 	 << "   * MSB       : " << MSB       << std::endl
+// 	 << std::dec
+// 	 << "   * index_min : " << index_min << std::endl
+// 	 << "   * index_max : " << index_max << std::endl
+// 	 << " * type        : " << type    << std::endl;
 
     if (index_max > _size_word)
@@ -218,8 +218,8 @@
     _data [context][MSB] = data_new;
     
-    cout << hex
-	 << "     * data_old    : " << data_old << endl
-	 << "     * data_new    : " << data_new << endl
-	 << dec;
+    std::cout << std::hex
+	      << "     * data_old    : " << data_old << std::endl
+	      << "     * data_new    : " << data_new << std::endl
+	      << std::dec;
 
 
@@ -277,9 +277,9 @@
 	  }
 	std::cout << " - "
-		  << hex
+		  << std::hex
 		  << i->_address << " : "
 		  << i->_data_old << " -> "
 		  << i->_data_new << std::endl
-		  << hex;
+		  << std::hex;
       }
   }
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/SelfTest/include/MemoryRequest.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/SelfTest/include/MemoryRequest.h	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/SelfTest/include/MemoryRequest.h	(revision 75)
@@ -126,11 +126,11 @@
   {
     return os << "<" << morpheo::toString(x._cycle) << "> : "
-	      << "{" << morpheo::toString(static_cast<uint32_t>(x._packet_id)) << "}" << endl
-	      << "\t * context / front_end / ooo_engine  : " << morpheo::toString(static_cast<uint32_t>(x._context_id   )) << " - " << morpheo::toString(static_cast<uint32_t>(x._front_end_id )) << " - " << morpheo::toString(static_cast<uint32_t>(x._ooo_engine_id)) << endl
-	      << "\t * operation  / type / write_spec_ko : " << morpheo::toString(static_cast<uint32_t>(x._operation)) << " " << morpheo::toString(static_cast<uint32_t>(x._type)) << " " << morpheo::toString(static_cast<uint32_t>(x._write_spec_ko)) << endl
-	      << "\t * ptr_write store/load              : " << morpheo::toString(static_cast<uint32_t>(x._store_queue_ptr_write)) << " " << morpheo::toString(static_cast<uint32_t>(x._load_queue_ptr_write)) << endl
-	      << "\t * immediat / data_ra / data_rb      : " << morpheo::toString(static_cast<uint32_t>(x._immediat)) << " - " << morpheo::toString(static_cast<uint32_t>(x._data_ra)) << " - " << morpheo::toString(static_cast<uint32_t>(x._data_rb)) << endl
-	      << "\t * write_rd / num_reg_rd             : " << morpheo::toString(static_cast<uint32_t>(x._write_rd)) << " " << morpheo::toString(static_cast<uint32_t>(x._num_reg_rd)) << endl
-	      << "\t * data_wait                         : " << morpheo::toString(static_cast<uint32_t>(x._data_wait)) << endl;
+	      << "{" << morpheo::toString(static_cast<uint32_t>(x._packet_id)) << "}" << std::endl
+	      << "\t * context / front_end / ooo_engine  : " << morpheo::toString(static_cast<uint32_t>(x._context_id   )) << " - " << morpheo::toString(static_cast<uint32_t>(x._front_end_id )) << " - " << morpheo::toString(static_cast<uint32_t>(x._ooo_engine_id)) << std::endl
+	      << "\t * operation  / type / write_spec_ko : " << morpheo::toString(static_cast<uint32_t>(x._operation)) << " " << morpheo::toString(static_cast<uint32_t>(x._type)) << " " << morpheo::toString(static_cast<uint32_t>(x._write_spec_ko)) << std::endl
+	      << "\t * ptr_write store/load              : " << morpheo::toString(static_cast<uint32_t>(x._store_queue_ptr_write)) << " " << morpheo::toString(static_cast<uint32_t>(x._load_queue_ptr_write)) << std::endl
+	      << "\t * immediat / data_ra / data_rb      : " << morpheo::toString(static_cast<uint32_t>(x._immediat)) << " - " << morpheo::toString(static_cast<uint32_t>(x._data_ra)) << " - " << morpheo::toString(static_cast<uint32_t>(x._data_rb)) << std::endl
+	      << "\t * write_rd / num_reg_rd             : " << morpheo::toString(static_cast<uint32_t>(x._write_rd)) << " " << morpheo::toString(static_cast<uint32_t>(x._num_reg_rd)) << std::endl
+	      << "\t * data_wait                         : " << morpheo::toString(static_cast<uint32_t>(x._data_wait)) << std::endl;
   }
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/include/Load_store_unit.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/include/Load_store_unit.h	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/include/Load_store_unit.h	(revision 75)
@@ -30,7 +30,4 @@
 #include "Behavioural/include/Vhdl.h"
 #endif
-
-using namespace std;
-using namespace morpheo::behavioural::generic::queue_control;
 
 namespace morpheo {
@@ -51,5 +48,5 @@
     // -----[ fields ]----------------------------------------------------
     // Parameters
-  protected : const string       _name;
+  protected : const std::string       _name;
 
   protected : const Parameters * _param;
@@ -194,5 +191,5 @@
    sc_module_name                                name,
 #else					       
-   string                                        name,
+   std::string                                   name,
 #endif					       
 #ifdef STATISTICS
@@ -221,5 +218,4 @@
 #ifdef STATISTICS
   public  : void     statistics_declaration    (morpheo::behavioural::Parameters_Statistics * param_statistics);
-  public  : string   statistics_print          (uint32_t depth);
 #endif
 					       
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_allocation.cpp	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_allocation.cpp	(revision 75)
@@ -24,6 +24,4 @@
   void Load_store_unit::allocation (void)
   {
-    string rename;
-
     log_printf(FUNC,Load_store_unit,FUNCTION,"Begin");
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_function_speculative_load_commit_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_function_speculative_load_commit_transition.cpp	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_function_speculative_load_commit_transition.cpp	(revision 75)
@@ -660,33 +660,33 @@
 #if DEBUG>=DEBUG_TRACE
 	// ***** dump store queue
-	cout << "Dump STORE_QUEUE :" << endl
-	     << "ptr_read : " << toString(static_cast<uint32_t>(reg_STORE_QUEUE_PTR_READ)) << endl;
+	std::cout << "Dump STORE_QUEUE :" << std::endl
+		  << "ptr_read : " << toString(static_cast<uint32_t>(reg_STORE_QUEUE_PTR_READ)) << std::endl;
 	
 	for (uint32_t i=0; i<_param->_size_store_queue; i++)
 	  {
 	    uint32_t j = (reg_STORE_QUEUE_PTR_READ+i)%_param->_size_store_queue;
-	    cout << "{" << j << "}" << endl
-		 << _store_queue[j] << endl;
+	    std::cout << "{" << j << "}" << std::endl
+		      << _store_queue[j] << std::endl;
 	  }
 
 	// ***** dump speculative_access queue
-	cout << "Dump SPECULATIVE_ACCESS_QUEUE :" << endl;
+	std::cout << "Dump SPECULATIVE_ACCESS_QUEUE :" << std::endl;
 	
 	for (uint32_t i=0; i<_param->_size_speculative_access_queue; i++)
 	  {
 	    uint32_t j = (*_speculative_access_queue_control)[i];
-	    cout << "{" << j << "}" << endl
-		 << _speculative_access_queue[j] << endl;
+	    std::cout << "{" << j << "}" << std::endl
+		 << _speculative_access_queue[j] << std::endl;
 	  }
 
 	// ***** dump load queue
-	cout << "Dump LOAD_QUEUE :" << endl
-	     << "ptr_read_check_priority : " << toString(static_cast<uint32_t>(reg_LOAD_QUEUE_CHECK_PRIORITY)) << endl;
+	std::cout << "Dump LOAD_QUEUE :" << std::endl
+	     << "ptr_read_check_priority : " << toString(static_cast<uint32_t>(reg_LOAD_QUEUE_CHECK_PRIORITY)) << std::endl;
 	
 	for (uint32_t i=0; i<_param->_size_load_queue; i++)
 	  {
 	    uint32_t j = i;
-	    cout << "{" << j << "}" << endl
-		 << _load_queue[j] << endl;
+	    std::cout << "{" << j << "}" << std::endl
+		 << _load_queue[j] << std::endl;
 	  }
 	
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/include/Parameters.h	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/include/Parameters.h	(revision 75)
@@ -77,9 +77,9 @@
   public : ~Parameters () ;
 
-  public : string msg_error (void);
+  public : std::string          msg_error (void);
 
-  public :        string   print      (uint32_t depth);
-  public : friend ostream& operator<< (ostream& output_stream,
-				       morpheo::behavioural::core::multi_execute_loop::execute_loop::multi_read_unit::read_unit::read_queue::Parameters & x);
+  public :        std::string   print      (uint32_t depth);
+  public : friend std::ostream& operator<< (std::ostream& output_stream,
+					    morpheo::behavioural::core::multi_execute_loop::execute_loop::multi_read_unit::read_unit::read_queue::Parameters & x);
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/include/Read_queue.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/include/Read_queue.h	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/include/Read_queue.h	(revision 75)
@@ -21,5 +21,5 @@
 #include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/include/Parameters.h"
 #ifdef STATISTICS
-#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/include/Statistics.h"
+#include "Behavioural/include/Stat.h"
 #endif
 #include "Behavioural/include/Component.h"
@@ -27,6 +27,4 @@
 #include "Behavioural/include/Vhdl.h"
 #endif
-
-using namespace std;
 
 namespace morpheo {
@@ -60,25 +58,25 @@
   public    : Tspecial_address_t _num_reg_re   ;
 
-    friend ostream& operator<< (ostream& output_stream,
+    friend std::ostream& operator<< (std::ostream& output_stream,
 				morpheo::behavioural::core::multi_execute_loop::execute_loop::multi_read_unit::read_unit::read_queue::Tread_queue_entry_t & x)
     {
-      output_stream << " * _context_id    : " << toString(x._context_id   ) << endl
-		    << " * _front_end_id  : " << toString(x._front_end_id ) << endl
-		    << " * _ooo_engine_id : " << toString(x._ooo_engine_id) << endl
-		    << " * _rob_id        : " << toString(x._rob_id       ) << endl
-		    << " * _operation     : " << toString(x._operation    ) << endl
-		    << " * _type          : " << toString(x._type         ) << endl
-		    << " * _has_immediat  : " << toString(x._has_immediat ) << endl
-		    << " * _immediat      : " << toString(x._immediat     ) << endl
-		    << " * _read_ra       : " << toString(x._read_ra      ) << endl
-		    << " * _num_reg_ra    : " << toString(x._num_reg_ra   ) << endl
-		    << " * _read_rb       : " << toString(x._read_rb      ) << endl
-		    << " * _num_reg_rb    : " << toString(x._num_reg_rb   ) << endl
-		    << " * _read_rc       : " << toString(x._read_rc      ) << endl
-		    << " * _num_reg_rc    : " << toString(x._num_reg_rc   ) << endl
-		    << " * _write_rd      : " << toString(x._write_rd     ) << endl
-		    << " * _num_reg_rd    : " << toString(x._num_reg_rd   ) << endl
-		    << " * _write_re      : " << toString(x._write_re     ) << endl
-		    << " * _num_reg_re    : " << toString(x._num_reg_re   ) << endl;
+      output_stream << " * _context_id    : " << toString(x._context_id   ) << std::endl
+		    << " * _front_end_id  : " << toString(x._front_end_id ) << std::endl
+		    << " * _ooo_engine_id : " << toString(x._ooo_engine_id) << std::endl
+		    << " * _rob_id        : " << toString(x._rob_id       ) << std::endl
+		    << " * _operation     : " << toString(x._operation    ) << std::endl
+		    << " * _type          : " << toString(x._type         ) << std::endl
+		    << " * _has_immediat  : " << toString(x._has_immediat ) << std::endl
+		    << " * _immediat      : " << toString(x._immediat     ) << std::endl
+		    << " * _read_ra       : " << toString(x._read_ra      ) << std::endl
+		    << " * _num_reg_ra    : " << toString(x._num_reg_ra   ) << std::endl
+		    << " * _read_rb       : " << toString(x._read_rb      ) << std::endl
+		    << " * _num_reg_rb    : " << toString(x._num_reg_rb   ) << std::endl
+		    << " * _read_rc       : " << toString(x._read_rc      ) << std::endl
+		    << " * _num_reg_rc    : " << toString(x._num_reg_rc   ) << std::endl
+		    << " * _write_rd      : " << toString(x._write_rd     ) << std::endl
+		    << " * _num_reg_rd    : " << toString(x._num_reg_rd   ) << std::endl
+		    << " * _write_re      : " << toString(x._write_re     ) << std::endl
+		    << " * _num_reg_re    : " << toString(x._num_reg_re   ) << std::endl;
 
       return output_stream;
@@ -156,34 +154,34 @@
     }
 
-    friend ostream& operator<< (ostream& output_stream,
+    friend std::ostream& operator<< (std::ostream& output_stream,
 				morpheo::behavioural::core::multi_execute_loop::execute_loop::multi_read_unit::read_unit::read_queue::Tread_queue_head_entry_t & x)
     {
-      output_stream << " * _context_id    : " << x._context_id   << endl
-		    << " * _front_end_id  : " << x._front_end_id << endl
-		    << " * _ooo_engine_id : " << x._ooo_engine_id<< endl
-		    << " * _rob_id        : " << x._rob_id       << endl
-		    << " * _operation     : " << x._operation    << endl
-		    << " * _type          : " << x._type         << endl
-		    << " * _has_immediat  : " << x._has_immediat << endl
-		    << " * _immediat      : " << x._immediat     << endl
-		    << " * _read_ra       : " << x._read_ra      << endl
-		    << " * _read_ra_val   : " << x._read_ra_val  << endl 
-		    << " * _num_reg_ra    : " << x._num_reg_ra   << endl
-		    << " * _data_ra_val   : " << x._data_ra_val  << endl
-		    << " * _data_ra       : " << x._data_ra      << endl
-		    << " * _read_rb       : " << x._read_rb      << endl
-		    << " * _read_rb_val   : " << x._read_rb_val  << endl
-		    << " * _num_reg_rb    : " << x._num_reg_rb   << endl
-		    << " * _data_rb_val   : " << x._data_rb_val  << endl
-		    << " * _data_rb       : " << x._data_rb      << endl
-		    << " * _read_rc       : " << x._read_rc      << endl
-		    << " * _read_rc_val   : " << x._read_rc_val  << endl
-		    << " * _num_reg_rc    : " << x._num_reg_rc   << endl
-		    << " * _data_rc_val   : " << x._data_rc_val  << endl
-		    << " * _data_rc       : " << x._data_rc      << endl
-		    << " * _write_rd      : " << x._write_rd     << endl
-		    << " * _num_reg_rd    : " << x._num_reg_rd   << endl
-		    << " * _write_re      : " << x._write_re     << endl
-		    << " * _num_reg_re    : " << x._num_reg_re   << endl;
+      output_stream << " * _context_id    : " << x._context_id   << std::endl
+		    << " * _front_end_id  : " << x._front_end_id << std::endl
+		    << " * _ooo_engine_id : " << x._ooo_engine_id<< std::endl
+		    << " * _rob_id        : " << x._rob_id       << std::endl
+		    << " * _operation     : " << x._operation    << std::endl
+		    << " * _type          : " << x._type         << std::endl
+		    << " * _has_immediat  : " << x._has_immediat << std::endl
+		    << " * _immediat      : " << x._immediat     << std::endl
+		    << " * _read_ra       : " << x._read_ra      << std::endl
+		    << " * _read_ra_val   : " << x._read_ra_val  << std::endl 
+		    << " * _num_reg_ra    : " << x._num_reg_ra   << std::endl
+		    << " * _data_ra_val   : " << x._data_ra_val  << std::endl
+		    << " * _data_ra       : " << x._data_ra      << std::endl
+		    << " * _read_rb       : " << x._read_rb      << std::endl
+		    << " * _read_rb_val   : " << x._read_rb_val  << std::endl
+		    << " * _num_reg_rb    : " << x._num_reg_rb   << std::endl
+		    << " * _data_rb_val   : " << x._data_rb_val  << std::endl
+		    << " * _data_rb       : " << x._data_rb      << std::endl
+		    << " * _read_rc       : " << x._read_rc      << std::endl
+		    << " * _read_rc_val   : " << x._read_rc_val  << std::endl
+		    << " * _num_reg_rc    : " << x._num_reg_rc   << std::endl
+		    << " * _data_rc_val   : " << x._data_rc_val  << std::endl
+		    << " * _data_rc       : " << x._data_rc      << std::endl
+		    << " * _write_rd      : " << x._write_rd     << std::endl
+		    << " * _num_reg_rd    : " << x._num_reg_rd   << std::endl
+		    << " * _write_re      : " << x._write_re     << std::endl
+		    << " * _num_reg_re    : " << x._num_reg_re   << std::endl;
 
       return output_stream;
@@ -198,9 +196,9 @@
     // -----[ fields ]----------------------------------------------------
     // Parameters
-  protected : const string                     _name;
+  protected : const std::string                _name;
   protected : const Parameters               * _param;
 
 #ifdef STATISTICS
-  private   : Statistics                     * _stat;
+  public    : Stat                           * _stat;
 #endif
 
@@ -302,5 +300,5 @@
     // ~~~~~[ Register ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
   protected : Tread_queue_head_entry_t       * _queue_head;
-  protected : queue<Tread_queue_entry_t *>   * _queue;
+  protected : std::queue<Tread_queue_entry_t *>   * _queue;
 
     // ~~~~~[ Internal ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
@@ -328,5 +326,5 @@
 					      sc_module_name                              name,
 #else					       
-					      string                                      name,
+					      std::string                                 name,
 #endif					       
 #ifdef STATISTICS
@@ -349,5 +347,5 @@
 #endif					       
 #ifdef STATISTICS
-  public  : string   statistics                (uint32_t depth);
+  public  : void     statistics_declaration    (morpheo::behavioural::Parameters_Statistics * param_statistics);
 #endif
 					       
@@ -357,7 +355,7 @@
   private : void     vhdl_body                 (Vhdl * & vhdl);
 #endif					       
-					       
-#ifdef VHDL_TESTBENCH			       
-  private : void     vhdl_testbench_transition (void);
+			
+#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+  private : void     end_cycle                 (void);
 #endif
   };
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Parameters_msg_error.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Parameters_msg_error.cpp	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Parameters_msg_error.cpp	(revision 75)
@@ -8,5 +8,4 @@
 #include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/include/Parameters.h"
 #include <sstream>
-using namespace std;
 
 namespace morpheo                    {
@@ -20,9 +19,9 @@
 
 
-  string Parameters::msg_error(void)
+  std::string Parameters::msg_error(void)
   {
     log_printf(FUNC,Read_queue,"msg_error","Begin");
 
-    string msg = "";
+    std::string msg = "";
 
 //     if (_size_queue < 2)
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Parameters_print.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Parameters_print.cpp	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Parameters_print.cpp	(revision 75)
@@ -8,5 +8,4 @@
 #include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/include/Parameters.h"
 #include "Behavioural/include/XML.h"
-using namespace std;
 
 namespace morpheo                    {
@@ -20,5 +19,5 @@
 
 
-  string Parameters::print (uint32_t depth)
+  std::string Parameters::print (uint32_t depth)
   {
     log_printf(FUNC,Read_queue,"print","Begin");
@@ -47,6 +46,6 @@
   };
 
-  ostream& operator<< (ostream& output_stream ,
-		       morpheo::behavioural::core::multi_execute_loop::execute_loop::multi_read_unit::read_unit::read_queue::Parameters & x)
+  std::ostream& operator<< (std::ostream& output_stream ,
+			    morpheo::behavioural::core::multi_execute_loop::execute_loop::multi_read_unit::read_unit::read_queue::Parameters & x)
   {
     output_stream << x.print(0);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Read_queue.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Read_queue.cpp	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Read_queue.cpp	(revision 75)
@@ -39,10 +39,7 @@
 
 #ifdef STATISTICS
-    log_printf(INFO,Read_queue,"Read_queue","Allocation of statistics");
-
-    // Allocation of statistics
-    _stat = new Statistics (static_cast<string>(_name),
-			    param_statistics          ,
-			    param);
+    log_printf(INFO,Read_queue,FUNCTION,"Allocation of statistics");
+    
+    statistics_declaration(param_statistics);
 #endif
 
@@ -217,6 +214,4 @@
     log_printf(INFO,Read_queue,"~Read_queue","Generate Statistics file");
 
-    _stat->generate_file(statistics(0));
-    
     delete _stat;
 #endif
